package cn.com.infosec.asn1;

import cn.com.infosec.util.io.Streams;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

public abstract class DERGenerator extends ASN1Generator {
   private boolean _tagged = false;
   private boolean _isExplicit;
   private int _tagNo;

   protected DERGenerator(OutputStream out) {
      super(out);
   }

   public DERGenerator(OutputStream out, int tagNo, boolean isExplicit) {
      super(out);
      this._tagged = true;
      this._isExplicit = isExplicit;
      this._tagNo = tagNo;
   }

   private void writeLength(OutputStream out, int length) {
      if (length > 127) {
         int var4 = 1;

         for(int var3 = length; (var3 >>>= 8) != 0; ++var4) {
         }

         out.write((byte)(var4 | 128));

         for(var4 = (var4 - 1) * 8; var4 >= 0; var4 -= 8) {
            out.write((byte)(length >> var4));
         }
      } else {
         out.write((byte)length);
      }

   }

   void writeDEREncoded(OutputStream out, int tag, byte[] bytes) {
      out.write(tag);
      this.writeLength(out, bytes.length);
      out.write(bytes);
   }

   void writeDEREncoded(int tag, byte[] bytes) {
      if (this._tagged) {
         int var3;
         int var4 = (var3 = this._tagNo) | 128;
         DERGenerator var10000;
         OutputStream var5;
         if (this._isExplicit) {
            var10000 = this;
            int var10001 = var3 | 32 | 128;
            ByteArrayOutputStream var7;
            ByteArrayOutputStream var10002 = var7 = new ByteArrayOutputStream;
            var7.<init>();
            this.writeDEREncoded(var7, tag, (byte[])bytes);
            var5 = super._out;
            byte[] tag1 = var10002.toByteArray();
            var10000.writeDEREncoded(var5, var10001, tag1);
         } else if ((tag & 32) != 0) {
            var10000 = this;
            var5 = super._out;
            var10000.writeDEREncoded(var5, var4 | 32, bytes);
         } else {
            this.writeDEREncoded(super._out, var4, bytes);
         }
      } else {
         this.writeDEREncoded(super._out, tag, bytes);
      }

   }

   void writeDEREncoded(OutputStream out, int tag, InputStream in) {
      DERGenerator var10000 = this;
      byte[] var4 = Streams.readAll(in);
      var10000.writeDEREncoded(out, tag, var4);
   }
}
